<?php
#-------------------------------------------------------
# Path: /parsing/main.php			     					 
# Creation date: 2010-06-07 (MySql date format)						 						 
# Creator: Joel Snchez aka "Kazer", Excelis' main programmer							 
# Description:	 
#	Main template parsing file.
#-------------------------------------------------------

#Ok, so you just arrived to /parsing/main.php. Welcome. This is one of the most complicated and long scripts in Excelis.
#I'll do what I can for you to understand all this bullshit, but I don't promise anything.

#SECURITY

#Define a global constant ('INDICE') to access other system files that we are gonna include, as they require this constant to be set in order to work.
define('_INDICE_',true);
 
 
#MYSQL CONNECTION AND INITIAL VARIABLES

#Use microtime() in order to calculate the script generation time later.
$T_inicio = microtime();
#User's IP
$ip = $_SERVER['REMOTE_ADDR'];
#Include the main configuration file
include "../config.php";
#In case of not having any template defined, we avoid the error shitstorm by using the defined template by default
if ($template == "") {
	$template = $default_template;
}
#Rename the original configuration variables, as those are their names in this file.
$config_title = $welcome_title;
$config_name = $name;
#Base path of Excelis
$base_path = str_replace("\\", "/", realpath('../')); #/home/kazer/public_html/excelis
#MySQL connection
$conexion = mysql_connect($database_servidor, $database_usuario, $database_pass);
#MySQL database selection
mysql_select_db($database_nombre, $conexion);


#USERDATA: SESSION AND COOKIES

#Include the file that will get the session and cookie data for us.
include '../system/userdata.php';
#Run the function for getting cookies. Cause we love cookies.
sendcookies();
#Get all the necessary variables using the functions in the included file
$theme = cookiedata("theme");
$language = cookiedata("language");
$cookie_id = cookiedata("id");
$fol = cookiedata("fol");
$user_id = sessiondata("user_id");
$user_pass = sessiondata("user_pass");
$user_board = sessiondata("user_board");
$user_name = sessiondata("user");
$user_logged = sessiondata("user_logged");
$user_rank = sessiondata("user_rank");
#Check if there is any publicity image.
if (file_exists('../images/publicity.png')) {
	$publicity = true;
} else {
	$publicity = false;
}
#Check if the user is administrator, moderator, or just a simple user who has no rights.
if($user_logged == true){
	if($user_board == $board_letter AND $user_rank == "moderator") {
	$rank = "moderator";
	} elseif ($user_rank == "administrator") {
	$rank = "administrator";
	$administrator = TRUE;
	}
}


#REQUIRED FILE INCLUSION

#Strings file inclusion. No strings file = epic fail
include "../strings/".$language.".php"; 
#Template color file inclusion.
include "../templates/".$template."/themes/".$theme."/colors.php";


#PATH VARIABLES

#Just don't touch this. It sets the relative path to the base path of Excelis (if we are in /excelis/boards/b, $rel would be ../../)

#Set this $rel if we are not in a thread and there is no page defined (we are obviously in something like /boards/b). If $uri is defined, change the $rel. 
#[Note: $uri changes if we access /boards/b or /boards/b/ for obvious reasons, and so does $rel]
if ($thread == "" AND $_GET['p'] == "") {
	if ($uri != "") {
	$rel = "../";
	} else {
	$rel = "../../";
	}
#Set this $rel if we are in a thread and the page is not null (although that's just impossible; see the explanation a few lines later). This is just a failsafe option.
} else {
	if ($uri != "") {
	$rel = "../../../";
	} else {
	$rel = "../../../../";
	}
}
#Set this $rel if the page is not null (we are obviously in something like /boards/b/1)
#The thread is gonna be null if the page is defined since you can't browse the board and look to a thread at the same time in the same page. No, seriously, stop thinking about it: YOU CAN'T.
#If $uri exists and/or we are in archive mode, set the $rel accordingly.
if ( $_GET['p'] != "") {
	if ($uri != "") {
	$rel = "../../";
	} else {
		if ($archive == 1) {
		$rel = "../../";
		} else {
		$rel = "../../../";
		}
	}
}


#FOLLOW VARIABLE UPDATING

#The follow variable is what makes possible the "follow thread" option in the akenboard template.
if ($thread != "") {
	$fol_explode = explode(";", $fol);
	$num = 0;
	while ($num != count($fol_explode)) {
		$fol_explode2 = explode(",", $fol_explode[$num]);
		if ($fol_explode2[0] != "" AND $fol_explode2[0] != "0" AND $fol_explode2[0] == $thread) {
			$fol = str_replace($fol_explode2[2], time(), $fol);
			$sql = mysql_query("UPDATE sessions SET fol = '".$fol."' WHERE id = '".$cookie_id."'") or die(mysql_error()."UPDATE sessions SET fol = '".$fol."' WHERE id = '".$cookie_id."'");
			$num = count($fol_explode);
		} else {
			$num += 1;
		}
	}

}


#THREAD CHECKING

#This basically checks if the thread exists. If it doesn't exist, redirects to a nice error page.
if ($thread != "") {
$usuario_consulta = mysql_query("SELECT num FROM posts WHERE reply = '0' AND board = '".$board_letter."' AND num = '".$thread."'") or die(mysql_error()."SELECT num FROM posts WHERE reply = '0' AND board = '".$board_letter."' AND num = '".$thread."'");
if (mysql_num_rows($usuario_consulta) == 0) {
header("Location: ".$rel."parsing/messages.php?m=thread&b=".$board_letter);
die;
}
}


#META-TAGS

#Gets the page meta-tags from the database.
$meta_array = array( 
	1=>"meta_title",
	2=>"meta_subject",
	3=>"meta_description",
	4=>"meta_keywords",
	5=>"meta_language",
	6=>"meta_revisit",
	7=>"meta_distribution",
	8=>"meta_robots");
	$meta_array2 = array();
$num = 0;
while ($num != count($meta_array)) {
$num += 1;
$usuario_consulta = mysql_query("SELECT id, text FROM strings WHERE parent = 'meta' AND id = '".$meta_array[$num]."'") or die(mysql_error()."SELECT id, text FROM strings WHERE parent = 'meta' AND id = '".$meta_array[$num]."'");
while ($registro = mysql_fetch_array($usuario_consulta)) {
	$$meta_array[$num] = $registro['text'];
}
}


#BOARD DATA
#This gets the board's description, title, category and icon. 

#MySQL query for getting the data.
$sql = mysql_query("SELECT letter, title, description, category FROM boards WHERE letter='".$board_letter."'") or die(mysql_error()."SELECT letter, title, description, category FROM boards WHERE letter='".$board_letter."'");

#Typical MySQL function to get typical MySQL rows and write the data in variables.
while ($registro = mysql_fetch_array($sql)) {
	$board_description = $registro['description'];
	$board_title = $registro['title'];
	$board_category = $registro['category'];
}

#Check if theere is any icon for this board.
$dir = "../images/boards";
$directorio=opendir($dir);
$found = 0;
while ($archivo = readdir($directorio) AND $found != 1) {
	if ($archivo != "." && $archivo != "..") {
		if (substr($archivo, 0, 1) == $board_letter) {
		$found = 1;
		$board_icon = $archivo;
		}
	}
}


#ADMINISTRATOR MESSAGES
#This checks if there is any message set by the administrator that we should show.

#In archive mode there aren't such messages, so we check this before doing anything at all.
if ($archive != "1") {
	#Typical MySQL query and typical mysql_fetch_array for getting the title and the body of the last administrator message.
	$board_consulta = mysql_query("SELECT title, text FROM messages ORDER BY date DESC LIMIT 0,1") or die(mysql_error()."SELECT title, text FROM messages ORDER BY date DESC LIMIT 0,1");
	while ($registro = mysql_fetch_array($board_consulta)) {
		$message_title = $registro['title'];
		$message_body = $registro['text'];
	}
} else {
	#If we are in the archive, the message box shows something like "You are in the archive of the board blablabla...."
	$message_title = "";
	$message_body = "<b>".str_replace("[board]", $board_letter, $board_archive_message)."</b>";
}
#Check if there is any message defined and define a conditional variable accordingly.
#Yeah, this should be a boolean variable. But I like numbers. They don't harm anybody.
if ($message_body == "") {
$cond_message = "0";
} else {
$cond_message = "1";
}


#TEMPLATE VARIABLE PARSING
#This is just part of the templates feature. In the template's html there are things like [rel], [version], and so on, so we replace that shit for the real variables. 
#So, [version] in the template would get replaced by the value of $version here. Simple as fuck.
#Btw, there are some strings in the strings file that have things like X and Y that are meant to be replaced. This one shows "Welcome, $user", but in the strings file it's defined like "Welcome, X" as in the strings file we haven't got any variable named $user and wouldn't make any effect.
$user_welcome = str_replace("X", $user_name, $check_logged);
#Script generation variable.
$microtime = substr(microtime() - $T_inicio,0,5);
#Get contents of the html file
$template_main = file_get_contents("../templates/".$template."/html/main.html");
#Shitstorm of variables to be replaced.
$replaces_array = array();
$replaces_array[] = "rel";
$replaces_array[] = "version";
$replaces_array[] = "template";
$replaces_array[] = "board_letter";
$replaces_array[] = "board_title";
$replaces_array[] = "board_description";
$replaces_array[] = "board_category";
$replaces_array[] = "config_title";
$replaces_array[] = "config_name";
$replaces_array[] = "language";
$replaces_array[] = "string_noscript";
$replaces_array[] = "string_back_button";
$replaces_array[] = "string_change_language_button";
$replaces_array[] = "string_change_color_button";
$replaces_array[] = "string_archive_button";
$replaces_array[] = "string_board_administration";
$replaces_array[] = "string_button_logout";
$replaces_array[] = "string_view_all_images";
$replaces_array[] = "string_post_new";
$replaces_array[] = "string_login_user";
$replaces_array[] = "string_login_pass";
$replaces_array[] = "string_user_welcome";
$replaces_array[] = "user_name";
$replaces_array[] = "user_rank";
$replaces_array[] = "user_board";
$replaces_array[] = "rank";
$replaces_array[] = "theme";
$replaces_array[] = "message_title";
$replaces_array[] = "message_body";
$replaces_array[] = "meta_title";
$replaces_array[] = "meta_subject";
$replaces_array[] = "meta_description";
$replaces_array[] = "meta_keywords";
$replaces_array[] = "meta_language";
$replaces_array[] = "meta_revisit";
$replaces_array[] = "meta_distribution";
$replaces_array[] = "meta_robots";
$replaces_array[] = "board_icon";
$replaces_array[] = "microtime";
$num = 0;
#Welcome back, wasn't such a long trip, was it?
#Well, now we replace all that shit in the html file.
while ($num != count($replaces_array)) {
	if (substr($replaces_array[$num], 0, 7) == "string_" ) {
	$replace2 = str_replace("string_", "", $replaces_array[$num]);
	$template_main = str_replace("[".$replaces_array[$num]."]", $$replace2, $template_main);
	} else {
	$template_main = str_replace("[".$replaces_array[$num]."]", $$replaces_array[$num], $template_main);
	}
	$num += 1;
}


#TEMPLATE CONDITIONS PARSING
#Yep. In the template there are things like [IF_ARCHIVE_TRUE], which are the equivalent in a php file to "if ($archive == TRUE) { ...". Here we interpretate that conditions. If something like this:
#[IF_ARCHIVE_TRUE] html code that would be showed in archive mode only [/IF_ARCHIVE_TRUE]
#...if we are in the archive the html code will be showed and the condition will be deleted. If we aren't, nothing will be shown.
$template_main = str_replace("\n", "[template_line]", $template_main);
function preg_condition ($string, $condition, $condition_name, $bool) {
    $search = array('/\['.$condition_name.'\](.*?)\[\/'.$condition_name.'\]/');
	if ($condition == "0" OR $condition == "" OR $condition == false) {
		if ($bool == true) {
		$replace = array('');
		} elseif ($bool == false) {
		$replace = array('\\1');
		}
	} else {
		if ($bool == true) {
		$replace = array('\\1');
		} elseif ($bool == false) {
		$replace = array('');
		}
	}
    return preg_replace($search, $replace, $string);
}

$template_main = preg_condition ($template_main, $cond_message, "IF_MESSAGE_EXISTS", true);
$template_main = preg_condition ($template_main, $user_logged, "IF_USER_LOGGED_TRUE", true);
$template_main = preg_condition ($template_main, $user_logged, "IF_USER_LOGGED_FALSE", false);
$template_main = preg_condition ($template_main, $archive, "IF_ARCHIVE_FALSE", false);
$template_main = preg_condition ($template_main, $archive, "IF_ARCHIVE_TRUE", true);
$template_main = preg_condition ($template_main, $board_icon, "IF_BOARD_ICON_FALSE", false);
$template_main = preg_condition ($template_main, $board_icon, "IF_BOARD_ICON_TRUE", true);
$template_main = preg_condition ($template_main, $thread, "IF_THREAD_FALSE", false);
$template_main = preg_condition ($template_main, $publicity, "IF_PUBLICITY_TRUE", true);
$template_main = preg_condition ($template_main, $administrator, "IF_ADMINISTRATOR", true);



#TEMPLATE LOOP PARSING
#Same as the conditions but now with loops (while () {....). Example:
#[SHOW_LANGUAGES_BUTTONS] html to be used for a button [/SHOW_LANGUAGES_BUTTONS]
#will result in a list of languages using the html specified between the tags.
#I am not gonna comment this since it's not meant to be modified and it's just too long for such a lazy person like me.
function preg_while ($string, $while_name) {
	$x = 0;
	$array = array();
    $search = '/\['.$while_name.'\](.*?)\[\/'.$while_name.'\]/';

    if ($c=preg_match_all($search, $string, $matches)) {
	while ($x <= count($matches[0])) {
    $word1=$matches[0][$x];
	array_push($array, $x, $word1);
	$x += 1;
	}
	}
	$return = $array[1];
	$return = str_replace("[".$while_name."]", "", $return);
	$return = str_replace("[/".$while_name."]", "", $return);
	#$return = str_replace("[template_line]", "\n", $return);
	return $return;
}
$show_themes_buttons_match = preg_while($template_main, "SHOW_THEMES_BUTTONS");
if ($show_themes_buttons_match != "" AND $show_themes_buttons_match != "0") {
	include '../templates/'.$template.'/themes.php';
	for ($i=0;$i<=count($themes);$i++) {
		if ($themes[$i] != "") {
		include '../templates/'.$template.'/themes/'.$themes[$i].'/colors.php';
		$show_themes_button = str_replace("[showing_theme_id]", $themes[$i], $show_themes_buttons_match);
		$show_themes_button = str_replace("[showing_bgcolor]", $bgcolor_theme_button, $show_themes_button);
		$show_themes_button = str_replace("[showing_color]", $color_theme_button, $show_themes_button);
		$show_themes_buttons .= $show_themes_button;
		}
	}
	$template_main = str_replace($show_themes_buttons_match, $show_themes_buttons, $template_main);
	$template_main = str_replace("[SHOW_THEMES_BUTTONS]", "", $template_main);
	$template_main = str_replace("[/SHOW_THEMES_BUTTONS]", "", $template_main);
}
$show_languages_buttons_match = preg_while($template_main, "SHOW_LANGUAGES_BUTTONS");
if ($show_languages_buttons_match != "" AND $show_languages_buttons_match != "0") {
	$dir = "../strings/";
	$directorio=opendir($dir);
	while ($archivo = readdir($directorio)) {
		if ($archivo != "." && $archivo != "..") {
			if ($language == str_replace(".php", "", $archivo)) {
			$language_activo = "activo";
			} else {
			$language_activo = "";
			}
			$array = "1";
			include '../strings/'.$archivo;
			$showing_language_id = str_replace(".php", "", $archivo);
			$showing_language_name = $languages_array[str_replace(".php", "", $archivo)];
			$show_languages_button = str_replace("[showing_language_id]", $showing_language_id, $show_languages_buttons_match);
			$show_languages_button = str_replace("[showing_language_name]", $showing_language_name, $show_languages_button);
			$show_languages_button = str_replace("[language_activo]", $language_activo, $show_languages_button);
			$show_languages_buttons .= $show_languages_button;
			
		}
	} #while
	$template_main = str_replace($show_languages_buttons_match, $show_languages_buttons, $template_main);
	$template_main = str_replace("[SHOW_LANGUAGES_BUTTONS]", "", $template_main);
	$template_main = str_replace("[/SHOW_LANGUAGES_BUTTONS]", "", $template_main);
}
$show_pages_buttons_match = preg_while($template_main, "SHOW_PAGES_BUTTONS");
if ($show_pages_buttons_match != "" AND $show_pages_buttons_match != "0") {
	if ($archive != 1) {
	$usuario_consulta = mysql_query("SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='0' AND board = '".$board_letter."' ORDER BY fecha DESC") or die(mysql_error()."SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='0' AND board = '".$board_letter."' ORDER BY pos DESC");
	} else {
	$usuario_consulta1 = mysql_query("SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='0' AND board = '".$board_letter."' ORDER BY fecha DESC") or die(mysql_error()."SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='0' AND board = '".$board_letter."' ORDER BY pos DESC");
	$num_rows = mysql_num_rows($usuario_consulta1);
	$limit = $post_limit * $pages_limit;
	$usuario_consulta = mysql_query("SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='0' AND board = '".$board_letter."' ORDER BY num DESC LIMIT ".$limit.",".$num_rows) or die(mysql_error()."SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='0' AND board = '".$board_letter."' ORDER BY pos DESC LIMIT ".$limit.",".$num_rows);
	}
	
	if (mysql_num_rows($usuario_consulta) != 0) {
		$num_posts = mysql_num_rows($usuario_consulta);
		$num_pages = ceil($num_posts / $post_limit);
		mysql_free_result($usuario_consulta);
	}
	$actual_page = 1;
	if ($archive != 1) {
	while ($actual_page <= $num_pages AND $actual_page <= $pages_limit) {
		if ($page == $actual_page) {
		$page_activo = "activo";
		} else {
		$page_activo = "";
		}
		$show_pages_button = str_replace("[showing_page]", $actual_page, $show_pages_buttons_match);
		$show_pages_button = str_replace("[page_activo]", $page_activo, $show_pages_button);
		$show_pages_buttons .= $show_pages_button;
		$actual_page += 1;
	}
	} else {
	while ($actual_page <= $num_pages) {
		if ($page == $actual_page) {
		$page_activo = "activo";
		} else {
		$page_activo = "";
		}
		$show_pages_button = str_replace("[showing_page]", $actual_page, $show_pages_buttons_match);
		$show_pages_button = str_replace("[page_activo]", $page_activo, $show_pages_button);
		$show_pages_buttons .= $show_pages_button;
		$actual_page += 1;
	}
	}
	$template_main = str_replace($show_pages_buttons_match, $show_pages_buttons, $template_main);
	$template_main = str_replace("[SHOW_PAGES_BUTTONS]", "", $template_main);
	$template_main = str_replace("[/SHOW_PAGES_BUTTONS]", "", $template_main);
}
$show_follow_messages_match = preg_while($template_main, "SHOW_FOLLOW_MESSAGES");
if ($show_follow_messages_match != "" AND $show_follow_messages_match != "0") {
	$conexion = mysql_connect($database_servidor, $database_usuario, $database_pass); 						#Datos de conexion
	mysql_select_db($database_nombre, $conexion);
	$fol = cookiedata("fol");
	$fol_explode = explode(";", $fol);
	if ($fol_explode[0] != "") {
	$num = 0;
	while ($num != count($fol_explode)) {
		$fol_explode2 = explode(",", $fol_explode[$num]);
		if ($fol_explode2[0] != "" AND $fol_explode2[0] != "0") {
		$sql = mysql_query("SELECT num FROM posts WHERE num = '".$fol_explode2[0]."' AND board = '".$fol_explode2[1]."'") or die(mysql_error()."SELECT num FROM posts WHERE num = '".$fol_explode2[0]."' AND board = '".$fol_explode2[1]."'");
		while ($registro = mysql_fetch_array($sql)) {
			$num_post = $registro['num'];
		}
		if ($num_post != "") {
			$sql_date = date('Y-m-d H:i:s', $fol_explode2[2]);
			$sql2 = mysql_query("SELECT num, fecha FROM posts WHERE reply = '".$fol_explode2[0]."'") or die(mysql_error()."SELECT num, fecha FROM posts WHERE reply = '".$fol_explode2[0]."' AND board = '".$fol_explode2[1]."'");
			$num_replies = 0;
			while ($registro2 = mysql_fetch_array($sql2)) {
				$fecha_reply = strtotime($registro2['fecha']);
				if ($fol_explode2[2] < $fecha_reply) {
					$num_replies += 1;
				}
			}
			if ($num_replies != "0" AND $num_replies != "") {
						$show_follow_message = str_replace("[showing_follow_num]", $num_post, $show_follow_messages_match);
						$show_follow_message = str_replace("[showing_follow_replies]", $num_replies, $show_follow_message);
						
						
						$show_follow_messages .= $show_follow_message;
					}
		}
		}
		$num += 1;
	}
	}
	$template_main = str_replace($show_follow_messages_match, $show_follow_messages, $template_main);
	$template_main = str_replace("[SHOW_FOLLOW_MESSAGES]", "", $template_main);
	$template_main = str_replace("[/SHOW_FOLLOW_MESSAGES]", "", $template_main);
}
$template_main = str_replace("[template_line]", "\n", $template_main);


#TEMPLATE FILE INCLUDES PARSING
#This is the main template parsing file, so we can use the other template parsing files in order to make the imageboard. This is the "frame" for the rest of things. We can include board.php for showing the posts and its replies, menu.php for showing the boards menu, archive.php for showing the archive (works where board.php would work), and posting_square.php for showing the posting square where the users can make posts.

#We use eval() for getting the html code generate by the other parsing files and store it in variables
$include_menu = eval("?>".file_get_contents($base_path."/parsing/menu.php"));
if ($archive == 1) {
$include_archive = eval("?>".file_get_contents($base_path."/parsing/archive.php"));
} else {
$include_board = eval("?>".file_get_contents($base_path."/parsing/board.php"));
}
$thr_post_sq = "";
$include_posting_square = eval("?>".file_get_contents($base_path."/parsing/posting_square.php"));

#Then, we replace the calls to the parsing files with the html generated by them.
$template_main = str_replace("[TEMPLATE_MENU]", $template_menu, $template_main);
$template_main = str_replace("[TEMPLATE_BOARD]", $echo_board, $template_main);
$template_main = str_replace("[TEMPLATE_ARCHIVE]", $echo_archive, $template_main);
$template_main = str_replace("[TEMPLATE_POSTING_SQUARE]", $template_posting_square, $template_main);

#Finally, we use echo to show all the generated html file.
echo $template_main;
?>
