<?php
#-------------------------------------------------------
# Path: /config.php			     					 
# Creation date: 2010-06-07 (MySql date format)						 						 
# Creator: Joel Snchez aka "Kazer", Excelis' main programmer							 
# Description:	 
#	Gets Excelis' configuration from the database.
#-------------------------------------------------------

#Since config.php can be included from any Excelis file, we have to "guess" where is located the mysql configuration file.
if (file_exists('./mysql/mysql.txt')) {
$raw_mysql_data =  file_get_contents('./mysql/mysql.txt');
} elseif (file_exists('../mysql/mysql.txt')) {
$raw_mysql_data =  file_get_contents('../mysql/mysql.txt');
} elseif (file_exists('../../mysql/mysql.txt')) {
$raw_mysql_data =  file_get_contents('../../mysql/mysql.txt');
} else {
die();
}

$mysql_data_pieces = explode(";", $raw_mysql_data);

#config() function that will get for us the configuration variables from the database.
if (!(function_exists("config"))) {
function config($id) {
	$usuario_consulta = mysql_query("SELECT id, text FROM config WHERE id = '".$id."'") or die(mysql_error()."SELECT id, text FROM config WHERE id = '".$id."'");
	while ($registro = mysql_fetch_array($usuario_consulta)) {
		return $registro['text'];
	}
}
}
#MySQL connection variables
$database_servidor = $mysql_data_pieces[0];
$database_usuario = $mysql_data_pieces[1];
$database_pass = $mysql_data_pieces[2];
$database_nombre = $mysql_data_pieces[3];




#MySQL connection
$conexion = mysql_connect($database_servidor, $database_usuario, $database_pass);
mysql_select_db($database_nombre, $conexion);

#Use the config() function to get the configuration variables.
$welcome_title = config('welcome_title');
$name = config('name');
$reply_limit = config('reply_limit');
$post_limit = config('post_limit');
$pages_limit = config('pages_limit');
$chars_limit = config('chars_limit');
$email_length_limit = config('email_length_limit');
$name_length_limit = config('name_length_limit');
$title_length_limit = config('title_length_limit');

$photo_max_size = config('photo_max_size');
if (strpos($photo_max_size, "kb")) {
	$photo_max_size = str_replace("kb", "", $photo_max_size) * 1024;
} elseif (strpos($photo_max_size, "mb")) {
	$photo_max_size = str_replace("mb", "", $photo_max_size) * 1048576;
} elseif (strpos($photo_max_size, "gb")) {
	$photo_max_size = str_replace("gb", "", $photo_max_size) * 1073741824;
}
$hrphoto_max_size = config('hrphoto_max_size');
if (strpos($hrphoto_max_size, "kb")) {
	$hrphoto_max_size = str_replace("kb", "", $hrphoto_max_size) * 1024;
} elseif (strpos($hrphoto_max_size, "mb")) {
	$hrphoto_max_size = str_replace("mb", "", $hrphoto_max_size) * 1048576;
} elseif (strpos($hrphoto_max_size, "gb")) {
	$hrphoto_max_size = str_replace("gb", "", $hrphoto_max_size) * 1073741824;
}
$post_time = config('post_time');
if (strpos($post_time, "min")) {
	$post_time = str_replace("min", "", $post_time) * 60;
} elseif (strpos($post_time, "h")) {
	$post_time = str_replace("h", "", $post_time) * 3600;
} elseif (strpos($post_time, "d")) {
	$post_time = str_replace("d", "", $post_time) * 86400;
}
$default_theme = config('default_theme');
$session = config('session');
$default_template = config('default_template');
$template = config('template');
$chat_chars_limit = config('chat_chars_limit');
$version = config('version');
$captcha = config('captcha');
$thumbnail = config('thumbnail');
$thumbnail_reply = config('thumbnail_reply');
$toggle_video = config('toggle_video');
$toggle_url = config('toggle_url');
?>
