<?php
#-------------------------------------------------------
# Nombre: board.php		     					 
# Fecha de creacin: 7-6-10							 
# Fecha de modif.: 1-1-11								 
# Creador: Kazer Powa									 
# Descripcin:	 
#	Lista los posts de un board
#-------------------------------------------------------


#SEGURIDAD
$error = "<html><head><script>location.href='./parsing/messages.php?m=403';</script></head><body></body></html>";
#if (!defined('_INDICE_')) die($error); 
 define('_INDICE_',true);
 
 
#CONEXIN MYSQL Y VARIABLES INICIALES
$T_inicio = microtime(); 
$ip = $_SERVER['REMOTE_ADDR'];
include "../config.php";
if ($template == "") {
	$template = $default_template;
}
$config_title = $welcome_title;
$config_name = $name;
$archivo = "archivo";
$base_path = str_replace("\\", "/", realpath('../')); #/home/kazer/public_html/excelis
$conexion = mysql_connect($database_servidor, $database_usuario, $database_pass); 						#Datos de conexion
mysql_select_db($database_nombre, $conexion);


#DATOS DE USUARIO: SESIN Y COOKIES
$theme = cookiedata("theme");
$language = cookiedata("language");
$cookie_id = cookiedata("id");
$fol = cookiedata("fol");
$user_id = sessiondata("user_id");
$user_pass = sessiondata("user_pass");
$user_board = sessiondata("user_board");
$user_name = sessiondata("user");
$user_logged = sessiondata("user_logged");
$user_rank = sessiondata("user_rank");
if($user_logged == true){
	if($user_board == $board_letter AND $user_rank == "moderator") {
	$rank = "moderator";
	} elseif ($user_rank == "administrator") {
	$rank = "administrator";
	}
}


#INCLUSIN DE ARCHIVOS REQUERIDOS
include "../strings/".$language.".php"; 
include "../templates/".$template."/themes/".$theme."/colors.php";


#VARIABLES DE RUTA
if ($thread == "" AND $_GET['p'] == "") {
	if ($uri != "") {
	$rel = "../";
	} else {
	$rel = "../../";
	}
} else {
	if ($uri != "") {
	$rel = "../../../";
	} else {
	$rel = "../../../../";
	}
}
if ( $_GET['p'] != "") {
	if ($uri != "") {
	$rel = "../../";
	} else {
	$rel = "../../../";
	}
}


#PARSEAR LAS VARIABLES DE LA PLANTILLA
$template_board = file_get_contents("../templates/".$template."/html/board.html");
$replaces_array = array();
$replaces_array[] = "rel";
$replaces_array[] = "template";
$replaces_array[] = "board_letter";
$replaces_array[] = "board_title";
$replaces_array[] = "board_description";
$replaces_array[] = "board_category";
$replaces_array[] = "config_title";
$replaces_array[] = "config_name";
$replaces_array[] = "language";
$replaces_array[] = "string_button_reply";
$replaces_array[] = "string_button_thread";
$replaces_array[] = "string_button_ban";
$replaces_array[] = "string_button_quote";
$replaces_array[] = "string_button_delete";
$replaces_array[] = "string_button_ban0";
$replaces_array[] = "string_button_ban1";
$replaces_array[] = "string_button_ban2";
$replaces_array[] = "string_button_ban3";
$replaces_array[] = "string_button_ban4";
$replaces_array[] = "string_post_file";
$replaces_array[] = "string_return";
$replaces_array[] = "bgcolor_posting";
$replaces_array[] = "user_name";
$replaces_array[] = "user_rank";
$replaces_array[] = "user_board";
$replaces_array[] = "rank";
$replaces_array[] = "theme";
$replaces_array[] = "board_icon";
$replaces_array[] = "recent_thread_message";
$num = 0;
while ($num != count($replaces_array)) {
	if (substr($replaces_array[$num], 0, 7) == "string_" ) {
	$replace2 = str_replace("string_", "", $replaces_array[$num]);
	$template_board = str_replace("[".$replaces_array[$num]."]", $$replace2, $template_board);
	} else {
	$template_board = str_replace("[".$replaces_array[$num]."]", $$replaces_array[$num], $template_board);
	}
	$num += 1;
}
#PARSEAR LAS CONDICIONES DE LA PLANTILLA
$template_board = str_replace("\n", "[template_line]", $template_board);

$template_board = preg_condition ($template_board, $thread, "IF_THREAD_TRUE", true);
$template_board = preg_condition ($template_board, $archive, "IF_ARCHIVE_FALSE", false);
$template_board = preg_condition ($template_board, $archive, "IF_ARCHIVE_TRUE", true);

#PARSEAR LOS BUCLES DE LA PLANTILLA
$match_button_reply = preg_while($template_board, "BUTTON_REPLY");
$match_button_follow = preg_while($template_board, "BUTTON_FOLLOW");
$match_button_view = preg_while($template_board, "BUTTON_VIEW");
$match_button_quote = preg_while($template_board, "BUTTON_QUOTE");
$match_button_ban = preg_while($template_board, "BUTTON_BAN");
$match_button_delete = preg_while($template_board, "BUTTON_DELETE");
$match_button_quote_reply = preg_while($template_board, "BUTTON_QUOTE_REPLY");
$match_button_ban_reply = preg_while($template_board, "BUTTON_BAN_REPLY");
$match_button_delete_reply = preg_while($template_board, "BUTTON_DELETE_REPLY");
$match_replies_omitted = preg_while($template_board, "REPLIES_OMITTED");
$match_thread_image = preg_while($template_board, "THREAD_IMAGE");
$match_thread_normal = preg_while($template_board, "THREAD_NORMAL");
$match_reply_image = preg_while($template_board, "REPLY_IMAGE");
$match_reply_normal = preg_while($template_board, "REPLY_NORMAL");
$match_end_thread_false = preg_while($template_board, "END_THREAD_FALSE");
$match_end_thread_true = preg_while($template_board, "END_THREAD_TRUE");
$match_button_reply = str_replace("[template_line]", "\n", $match_button_reply);
$match_button_follow = str_replace("[template_line]", "\n", $match_button_follow);
$match_button_view = str_replace("[template_line]", "\n", $match_button_view);
$match_button_quote = str_replace("[template_line]", "\n", $match_button_quote);
$match_button_ban = str_replace("[template_line]", "\n", $match_button_ban);
$match_button_delete = str_replace("[template_line]", "\n", $match_button_delete);
$match_button_quote_reply = str_replace("[template_line]", "\n", $match_button_quote_reply);
$match_button_ban_reply = str_replace("[template_line]", "\n", $match_button_ban_reply);
$match_button_delete_reply = str_replace("[template_line]", "\n", $match_button_delete_reply);
$match_replies_omitted = str_replace("[template_line]", "\n", $match_replies_omitted);
$match_thread_image = str_replace("[template_line]", "\n", $match_thread_image);
$match_thread_normal = str_replace("[template_line]", "\n", $match_thread_normal);
$match_reply_image = str_replace("[template_line]", "\n", $match_reply_image);
$match_reply_normal = str_replace("[template_line]", "\n", $match_reply_normal);
$match_end_thread_false = str_replace("[template_line]", "\n", $match_end_thread_false);
$match_end_thread_true = str_replace("[template_line]", "\n", $match_end_thread_true);
?> 
<?php
if ($page > $pages_limit) {
die();
}
$ip = $_SERVER['REMOTE_ADDR'];
if ($thread == "") { #Si no estamos en un thread, mostrar esta query
	$usuario_consulta = mysql_query("SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='0' AND board = '".$board_letter."' ORDER BY pos DESC") or die(mysql_error()."SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='0' AND board = '".$board_letter."' ORDER BY pos DESC");
}else { #Si lo estamos, mostrar esta otra, que restringe al post a 1 numero determinado (Sthread)
$usuario_consulta = mysql_query("SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE num='".$thread."' AND reply='0' AND board = '".$board_letter."' ORDER BY pos DESC") or die(mysql_error()."SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE num='".$thread."' AND reply='0' AND board = '".$board_letter."' ORDER BY pos DESC");
}
if (mysql_num_rows($usuario_consulta) != 0) { #Si hay algun post....
	$previous_page = $page - 1; #...define cual es el numero de la pagina anterior
	function mysqltodate($MySQLFecha, $language) { #funcion para calcular fechas..IGNORAR.
				if (($MySQLFecha == "") or ($MySQLFecha == "0000-00-00 00:00:00") ) {
					return "";
				} else {
					$pieces = explode(" ", $MySQLFecha);
					ereg( "([0-9]{2,4})-([0-9]{1,2})-([0-9]{1,2})", $MySQLFecha, $mifecha);
					$fecha2=$mifecha[3]."-".$mifecha[2]."-".$mifecha[1]; #Tenemos una fecha DD-MM-AAAA
					if ($language == "english") {
					$fecha2_pieces = explode("-", $fecha2);
					$months = array();
					$months[] = "January";
					$months[] = "February";
					$months[] = "March";
					$months[] = "April";
					$months[] = "May";
					$months[] = "June";
					$months[] = "July";
					$months[] = "August";
					$months[] = "September";
					$months[] = "October";
					$months[] = "November";
					$months[] = "December";
					$num_month = $fecha2_pieces[1] - 1;
					$month = $months[$num_month];
					$fecha = $month." ".$fecha2_pieces[0].", ".$fecha2_pieces[2];	
					} else {
					$fecha = str_replace("-", "/", $fecha2);
					}
					return $fecha.' '.$pieces[1];
				}
			}
	while ($registro = mysql_fetch_array($usuario_consulta) and $post_count != $post_limit * $page) { #While que muestra todos los posts hasta alcanzar el limite
		$registro_num = $registro['num'];
		
		#FOLLOW
		$fol = cookiedata("fol");
		
		if ($registro_num != "") {
		$fol_explode = explode(";", $fol);
		$num = 0;
		while ($num != count($fol_explode)) {
			$fol_explode2 = explode(",", $fol_explode[$num]);
			if ($fol_explode2[0] != "" AND $fol_explode2[0] != "0" AND $fol_explode2[0] == $registro_num) {
				$showing_follow_button = $button_unfollow;
				$showing_follow_bool = 1;
				$num = count($fol_explode);
			} else {
				$showing_follow_bool = 0;
				$showing_follow_button = $button_follow;
				$num += 1;
			}
		}
		}
		#FECHA
		
		$fecha_post = $registro['fecha'];
		if (($fecha_post == "") or ($fecha_post == "0000-00-00 00:00:00") ) {
			$fecha_post = "";
		} else {
			$pieces = explode(" ", $fecha_post);
			ereg( "([0-9]{2,4})-([0-9]{1,2})-([0-9]{1,2})", $fecha_post, $mifecha);
			$fecha_post=$mifecha[3]."-".$mifecha[2]."-".$mifecha[1];
			$hoy = date('d-m-Y');
			#Tenemos 2 fechas en formato dia-mes-ao. Vamos a extraer el da de las dos fechas y a compararlo.
			$pieces1 = explode("-", $fecha_post);
			$pieces2 = explode("-", $hoy);
			if ($pieces1[1] == $pieces2[1] AND $pieces1[2] == $pieces2[2]) {
			if ($pieces1[0] == $pieces2[0]) {
			$fecha_post = "<b>".$post_date_today.', '.$pieces[1]."</b>";
			$thread_new_today = true;
			} elseif ($pieces1[0] == ($pieces2[0] - 1)){
			$fecha_post = $post_date_yesterday.', '.$pieces[1];
			$thread_new_today = false;
			} else {
			$fecha_post = mysqltodate($registro['fecha'], $language);
			$thread_new_today = false;
			}
			} else {
			$fecha_post = mysqltodate($registro['fecha'], $language);
			$thread_new_today = false;
			}
		}
		
		#BOTONES
		$button_thread_reply = str_replace("[showing_num]", $registro['num'], $match_button_reply);
		$button_thread_quote = str_replace("[showing_num]", $registro['num'], $match_button_quote);
		$button_thread_quote = str_replace("[showing_num_ant]", $registro['num'], $button_thread_quote);
		if ($thread == "") {
			$button_thread_follow = str_replace("[showing_num]", $registro['num'], $match_button_follow);
			$button_thread_follow = str_replace("[showing_follow_button]", $showing_follow_button, $button_thread_follow);
			$button_thread_follow = str_replace("[showing_follow_bool]", $showing_follow_bool, $button_thread_follow);
			$button_thread_view = str_replace("[showing_num]", $registro['num'], $match_button_view);
			if ($registro['pos'] == "-1") {
			$sticky = '<img src="'.$rel.'images/icons/sticky.png" />';
			} else {
			$sticky = "";
			}
		}
		if ($rank == "moderator" OR $rank == "administrator") {
			$button_post_ban = str_replace("[showing_num]", $registro['num'], $match_button_ban);
		} else {
			$button_post_ban = "";
		}
		if ($registro['ip'] == $ip OR $rank == "moderator" OR $rank == "administrator") {
			$button_post_delete = str_replace("[showing_num]", $registro['num'], $match_button_delete);
		} else {
			$button_post_delete = "";
		}
		if ($post_count >= $previous_page * $post_limit){ #Si el numero de post procesados es mayor que la pagina anterior * los posts por pagina, empieza el proceso de mostrarlos.
			$post_id = $registro['num'];
			$cuerpo1=$registro['cuerpo'];
			$cuerpo1 = str_replace('<', '&lt;', $cuerpo1);
			$cuerpo1 = str_replace('>', '&gt;', $cuerpo1);

			if(!function_exists("BBCode")) {
			function BBCode ($string, $board_letter, $rel) {
				$search = array(
				'/\[b\](.*?)\[\/b\]/',
				'/\[i\](.*?)\[\/i\]/',
				'/\[s\](.*?)\[\/s\]/',
				'/&gt;&gt;&gt;\/([a-zA-Z0-9]+)\//');
				$replace = array(
				'<b>\\1</b>',
				'<i>\\1</i>',
				'<u>\\1</u>',
				'</a><a onmouseover="link(1, this)" onmouseout="link(0, this)" class="link" href="'.$rel.'boards/\\1">&gt;&gt;&gt;/\\1/</a><a class="texto_post">');
			return preg_replace($search, $replace, $string);
			}
			}
			if(!function_exists("BBCode_url")) {
			function BBCode_url ($string, $board_letter, $rel) {
				$search = array('/http:\/\/(.*?)($|\n)/');
				$replace = array('</a><a onmouseover="link(1, this)" onmouseout="link(0, this)" class="link" target="_blank" href="http://\\1">http://\\1</a>'."<br /><a class=\"texto_post\">");
			return preg_replace($search, $replace, $string);
			}
			}
			$cuerpo1 = BBCode ($cuerpo1, $board_letter, $rel);
			if ($toggle_url == 1) { $cuerpo1 = BBCode_url ($cuerpo1, $board_letter, $rel); }
			
			#Video detection
			if(!function_exists("get_video")) {
			function get_video ($cuerpo) {
			if ($toggle_url == 1) {
			$regexp = '/<\/a><a onmouseover="link\(1, this\)" onmouseout="link\(0, this\)" class="link" target="_blank" href="http:\/\/www\.youtube\.com\/watch\?v=([a-zA-Z0-9-_]+)(.*?)">http:\/\/www\.youtube\.com\/watch\?v=([a-zA-Z0-9-_]+)(.*?)<\/a><br \/><a class="texto_post">/';
			} else {
			$regexp = '/http:\/\/www\.youtube\.com\/watch\?v=([a-zA-Z0-9-_]+)(.*?)/';
			}
			preg_match_all($regexp,$cuerpo,$youtube);
			for ($i=0;$i<=count($youtube[1]);$i++) {
				$yt_code = $youtube[1][$i];
				$sqlyt = mysql_query("SELECT url, title FROM video WHERE url = '".$yt_code."'") or die (mysql_error());
				if (mysql_num_rows($sqlyt) != 0) {
				while ($regyt = mysql_fetch_array($sqlyt)) {
					$yt_title = $regyt["title"];
				}
				}
				$yt_new = '</a><div class="video" onmouseover="video_div(1, this)" onmouseout="video_div(0, this)" onclick="video_display(\''.$yt_code.'\', \'1\')"><img  style="margin: 2px; float: left" src="http://i4.ytimg.com/vi/'.$yt_code.'/default.jpg" height="50px" /><div style="float: left"><a style="font-size: 18px; margin-left: 5px; color: #301905">Video</a><br /><a style="margin-left: 5px; margin-right: 5px; font-size: 14px; color: #40230B">'.$yt_title.'</a></div></div><div style="clear: both"></div><a class="texto_post">';
				$cuerpo = preg_replace($regexp, $yt_new, $cuerpo, 1);
			}
			return $cuerpo;
			}
			}
			if ($toggle_video == 1) {
			$cuerpo1 = get_video($cuerpo1);
			}
			
			
			#Quote detection
			if(!function_exists("get_quote")) {
			function get_quote($txt) {
				$x = "0";
				$array = array();
				$re1='&gt;&gt;(\\d+)';
				if ($c=preg_match_all ("/".$re1."/is", $txt, $matches)) {
					while ($x <= count($matches[1])) {
					$word1=$matches[1][$x];
					array_push($array, $x, $word1);
					$x += 1;
					}
				return $array;
				}
			}
			}
			$quotes_array = get_quote($cuerpo1);
			$y = "1";
			while ($y <= count($quotes_array)) {
				$id = $quotes_array[$y];
				if($id != "" AND $id != "0") {
					$sql37 = mysql_query("SELECT num, reply FROM posts WHERE num = '".$id."' AND board = '".$board_letter."'") or die(mysql_error()."SELECT num, reply FROM posts WHERE num = '".$id."' AND board = '".$board_letter."'");
					while ($registro37 = mysql_fetch_array($sql37)) {
						$id_ant = $registro37['reply'];
						if ($id_ant == 0) {
							$id_ant = $id;
						}
					}
					mysql_free_result($sql37);
					$cuerpo1 = str_replace('&gt;&gt;'.$id, '</a><a onmouseover="link(1, this)" onmouseout="link(0, this)" class="link" onclick="quote_color(\''.$id.'\')" href="'.$rel.'boards/'.$board_letter.'/thread/'.$id_ant.'#reply_'.$id.'">&gt;&gt;'.$id.'</a><a class="texto_post">', $cuerpo1);
				}
				$y += 2;
			}
			
			
			
			if(!function_exists("get_color")) {
			function get_color($txt) {
				$x = "0";
				$array = array();
				$re1='.*?';	# Non-greedy match on filler
				$re2='\\[color=';	# Uninteresting: word
				$re3='.*?';	# Non-greedy match on filler
				$re4='((?:[a-z][a-z]+))';	# Word 1
				$re8='.*?';	# Non-greedy match on filler
				$re9='\\]';	# Uninteresting: word
				$re10='.*?';	# Non-greedy match on filler
				if ($c=preg_match_all ("/".$re1.$re2.$re3.$re4."/is", $txt, $matches)) {
					while ($x <= count($matches[1])) {
					$word1=$matches[1][$x];
					array_push($array, $x, $word1);
					$x += 1;
					}
				return $array;
				}
			}
			}
			$colors_array = get_color($cuerpo1);
			$y = "0";
			while ($y <= count($colors_array)) {
				$theme = $colors_array[$y];
				if($theme != "" AND $theme != "0" AND $theme != "1") {
					if (file_exists('../templates/'.$template.'/themes/'.$theme.'/colors.php')) {
					include '../templates/'.$template.'/themes/'.$theme.'/colors.php';
					$cuerpo1 = str_replace('[color='.$theme.']', '<a style="color: '.$border_divreply.';">', $cuerpo1);
					$cuerpo1 = str_replace("[/color]", "</a>", $cuerpo1);
					} else {
					$cuerpo1 = str_replace('[color='.$theme.']', '', $cuerpo1);
					$cuerpo1 = str_replace("[/color]", "", $cuerpo1);
					}
					
				}
				$y += 1;
			}
			
			$dir = "../images/smileys";
		$directorio=opendir($dir);
		while ($archivo = readdir($directorio)) {
			if ($archivo != "." && $archivo != "..") {
			$archivo_noext = str_replace(".jpg", "", $archivo);
			$archivo_noext = str_replace(".jpeg", "", $archivo_noext);
			$archivo_noext = str_replace(".gif", "", $archivo_noext);
			$archivo_noext = str_replace(".png", "", $archivo_noext);
			$cuerpo1 = str_replace(":".$archivo_noext.":", "<img alt=\"Image\" src=\"".$rel."images/smileys/".$archivo."\" />", $cuerpo1);
			}
		} #while
		$sql = mysql_query("SELECT find, put FROM filters") or die(mysql_error()."SELECT find, put FROM filters");
			while ($registro_sql = mysql_fetch_array($sql)) {
				$cuerpo1 = str_replace($registro_sql['find'], $registro_sql['put'], $cuerpo1);
			}
			if ($thread_new_today == true) {
				$sql = mysql_query("SELECT num FROM posts WHERE board = '".$board_letter."' AND fecha >= '".$registro['fecha']."' AND num = '".$registro['num']."'") or die(mysql_error()."SELECT num FROM posts WHERE board = '".$board_letter."' AND fecha >= '".$registro['fecha']."' AND num = '".$registro['num']."'");
				if (mysql_num_rows($sql) <= 10) {
				$thread_new = true;
				} else {
				$thread_new = false;
				}
			} else {
			$thread_new = false;
			}
			if ($registro['foto'] != "0") { #Si hay foto, mostrar este post.
				$echo_board_add = str_replace("[template_line]", "\n", preg_condition (str_replace("\n", "[template_line]", $match_thread_image), $thread_new, "IF_THREAD_NEW", true));
				if ($registro['email'] != "") {
					$registro_email = "href=\"mailto:".$registro['email']."\"";
				} else {
					$registro_email = "";
				}
				$echo_board_add = str_replace("[showing_email]", $registro_email, $echo_board_add);
				$echo_board_add = str_replace("[showing_name]", $registro['nombre'], $echo_board_add);
				$echo_board_add = str_replace("[showing_date]", $fecha_post, $echo_board_add);
				$echo_board_add = str_replace("[showing_num]", $registro['num'], $echo_board_add);
				$echo_board_add = str_replace("[sticky]", $sticky, $echo_board_add);
				$echo_board_add = str_replace("[showing_ext]", $registro['foto'], $echo_board_add);
				$echo_board_add = str_replace("[showing_body]", $cuerpo1, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_quote]", $button_thread_quote, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_reply]", $button_thread_reply, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_view]", $button_thread_view, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_follow]", $button_thread_follow, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_ban]", $button_post_ban, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_delete]", $button_post_delete, $echo_board_add);
				$thr_post_sq = $registro['num'];
				include realpath('../parsing/posting_square.php');
				$thr_post_sq = "";
				$echo_board_add = str_replace("[showing_posting_square]", $template_posting_square, $echo_board_add);
				$echo_board .= $echo_board_add;
			} else { #Si no hay foto, mostramos este post.
				$echo_board_add = str_replace("[template_line]", "\n", preg_condition (str_replace("\n", "[template_line]", $match_thread_normal), $thread_new, "IF_THREAD_NEW", true));
				if ($registro['email'] != "") {
					$registro_email = "href=\"mailto:".$registro['email']."\"";
				} else {
					$registro_email = "";
				}
				$echo_board_add = str_replace("[showing_email]", $registro_email, $echo_board_add);
				$echo_board_add = str_replace("[showing_name]", $registro['nombre'], $echo_board_add);
				$echo_board_add = str_replace("[showing_date]", $fecha_post, $echo_board_add);
				$echo_board_add = str_replace("[showing_num]", $registro['num'], $echo_board_add);
				$echo_board_add = str_replace("[sticky]", $sticky, $echo_board_add);
				$echo_board_add = str_replace("[showing_body]", $cuerpo1, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_quote]", $button_thread_quote, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_reply]", $button_thread_reply, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_view]", $button_thread_view, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_follow]", $button_thread_follow, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_ban]", $button_post_ban, $echo_board_add);
				$echo_board_add = str_replace("[showing_button_delete]", $button_post_delete, $echo_board_add);
				$thr_post_sq = $registro['num'];
				include realpath('../parsing/posting_square.php');
				$thr_post_sq = "";
				$echo_board_add = str_replace("[showing_posting_square]", $template_posting_square, $echo_board_add);
				$echo_board .= $echo_board_add;
			}
			
			
	
		} #Fin de parte de mostrar el post raiz.
		$post_count += 1; #Aumentamos el numero de posts totales procesados a +1
		
		#Parte de replies
		if ($post_count - 1 >= $previous_page * $post_limit) { #Si el numero de posts procesados - 1 es mayor que la pagina anterior * los posts por pagina, empieza el proceso de mostrar los replies.
			$usuario_consulta2 = mysql_query("SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='".$post_id."' AND board = '".$board_letter."' ORDER BY num ASC") or die(mysql_error()."SELECT nombre, email, cuerpo, foto, reply, pos, ip, fecha, num FROM posts WHERE reply='".$post_id."' AND board = '".$board_letter."' ORDER BY num ASC"); #Query de los replies.
			if (mysql_num_rows($usuario_consulta2) != 0) { #Por si no hay replies!
				if ($thread != "") { $reply_limit = count(mysql_fetch_array($usuario_consulta2)); }
					$num_replies_base0 = mysql_num_rows($usuario_consulta2) - 1; #Cuenta los replies al hilo en base 0
					$num_replies_base1 = mysql_num_rows($usuario_consulta2); #Cuenta los replies al hilo en base 1
					if ($num_replies_base1 <= $reply_limit){ #Si el numero de respuestas es inferior al limite...
					$num = $num_replies_base0 * -1; #Num es el numero de respuestas en negativo
					} else {
					$num = $reply_limit * -1 + 1; #Si el numero de respuestas es igual o superior al limite, Num es igual al limite en negativo (+1)
					}
					while ($num != 1 and $reply_count != $reply_limit and $reply_count != $num_replies_base1) { #condicionales para mostrar solo el limite de respuestas y para al llegar al mismo
						$reply_nombre = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'nombre');
						$reply_email = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'email');
						$reply_cuerpo = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'cuerpo');
						$cuerpo2=$reply_cuerpo;
						$cuerpo2 = str_replace('<', '&lt;', $cuerpo2);
						$cuerpo2 = str_replace('>', '&gt;', $cuerpo2);
						$cuerpo2 = BBCode ($cuerpo2, $board_letter, $rel);
						#Video detection
						if ($toggle_video == 1) { $cuerpo2 = get_video($cuerpo2); }
						
						$colors_array = get_color($cuerpo2);
						$y = "0";
						while ($y <= count($colors_array)) {
							$theme = $colors_array[$y];
							if($theme != "" AND $theme != "0" AND $theme != "1") {
							
							if (file_exists('../templates/'.$template.'/themes/'.$theme.'/colors.php')) {
					include '../templates/'.$template.'/themes/'.$theme.'/colors.php';
					$cuerpo2 = str_replace('[color='.$theme.']', '<a style="color: '.$border_divreply.';">', $cuerpo2);
					$cuerpo2 = str_replace("[/color]", "</a>", $cuerpo2);
					} else {
					$cuerpo2 = str_replace('[color='.$theme.']', '', $cuerpo2);
					$cuerpo2 = str_replace("[/color]", "", $cuerpo2);
					}
							}
							$y += 1;
						}
						$quotes_array = get_quote($cuerpo2);
			$y = "1";
			while ($y <= count($quotes_array)) {
				$id = $quotes_array[$y];
				if($id != "" AND $id != "0") {
					$sql37 = mysql_query("SELECT num, reply FROM posts WHERE num = '".$id."' AND board = '".$board_letter."'") or die(mysql_error()."SELECT num, reply FROM posts WHERE num = '".$id."' AND board = '".$board_letter."'");
					while ($registro37 = mysql_fetch_array($sql37)) {
						$id_ant = $registro37['reply'];
						if ($id_ant == 0) {
							$id_ant = $id;
						}
					}
					mysql_free_result($sql37);
					$cuerpo2 = str_replace('&gt;&gt;'.$id, '</a><a onmouseover="link(1, this)" onmouseout="link(0, this)" class="link" onclick="quote_color(\''.$id.'\')" href="'.$rel.'boards/'.$board_letter.'/thread/'.$id_ant.'#reply_'.$id.'">&gt;&gt;'.$id.'</a><a class="texto_post">', $cuerpo2);
				}
				$y += 2;
			}
						$dir = "../images/smileys";
						$directorio=opendir($dir);
						while ($archivo = readdir($directorio)) {
							if ($archivo != "." && $archivo != "..") {
							$archivo_noext = str_replace(".jpg", "", $archivo);
							$archivo_noext = str_replace(".jpeg", "", $archivo_noext);
							$archivo_noext = str_replace(".gif", "", $archivo_noext);
							$archivo_noext = str_replace(".png", "", $archivo_noext);
							$cuerpo2 = str_replace(":".$archivo_noext.":", "<img alt=\"Image\" src=\"".$rel."images/smileys/".$archivo."\" />", $cuerpo2);
							}
						} #while
						$sql2 = mysql_query("SELECT find, put FROM filters") or die(mysql_error()."SELECT find, put FROM filters");
						while ($registro_sql2 = mysql_fetch_array($sql2)) {
							$cuerpo2 = str_replace($registro_sql2['find'], $registro_sql2['put'], $cuerpo2);
							}
						$reply_foto = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'foto');
						$reply_reply = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'reply');
						$reply_pos = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'pos');
						$reply_ip = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'ip');
						$reply_fecha = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'fecha');
						$reply_num = mysql_result($usuario_consulta2, $num_replies_base0 + $num, 'num');
						$button_thread_quote = str_replace("[showing_num]", $reply_num, $match_button_quote_reply);
						$button_thread_quote = str_replace("[showing_num_ant]", $post_id, $button_thread_quote);
						if ($rank == "moderator" OR $rank == "administrator") {
							$button_post_ban = str_replace("[showing_num]", $reply_num, $match_button_ban_reply);
						} else {
							$button_post_ban = "";
						}
						if ($reply_ip == $ip OR $rank == "moderator" OR $rank == "administrator") {
							$button_post_delete = str_replace("[showing_num]", $reply_num, $match_button_delete_reply);
						} else {
							$button_post_delete = "";
						}
						if ($reply_foto != "0") { #Si es un reply con foto....
							$reply_fecha = mysqltodate($reply_fecha, $language);
							if ($reply_email != "") {
					$reply_email2 = "href=\"mailto:".$reply_email."\"";
				} else {
					$reply_email2 = "";
				}
							$echo_board_add = str_replace("[showing_email]", $reply_email2, $match_reply_image);
							$echo_board_add = str_replace("[showing_name]", $reply_nombre, $echo_board_add);
							$echo_board_add = str_replace("[showing_date]", $reply_fecha, $echo_board_add);
							$echo_board_add = str_replace("[showing_num]", $reply_num, $echo_board_add);
							$echo_board_add = str_replace("[showing_ext]", $reply_foto, $echo_board_add);
							$echo_board_add = str_replace("[showing_body]", $cuerpo2, $echo_board_add);
							$echo_board_add = str_replace("[showing_button_quote]", $button_thread_quote, $echo_board_add);
							$echo_board_add = str_replace("[showing_button_ban]", $button_post_ban, $echo_board_add);
							$echo_board_add = str_replace("[showing_button_delete]", $button_post_delete, $echo_board_add);
							$echo_board .= $echo_board_add;
							$images_count += 1;
						} else { #Si es un reply sin foto...
							$reply_fecha = mysqltodate($reply_fecha, $language);
							if ($reply_email != "") {
					$reply_email2 = "href=\"mailto:".$reply_email."\"";
				} else {
					$reply_email2 = "";
				}
							$echo_board_add = str_replace("[showing_email]", $reply_email2, $match_reply_normal);
							$echo_board_add = str_replace("[showing_name]", $reply_nombre, $echo_board_add);
							$echo_board_add = str_replace("[showing_date]", $reply_fecha, $echo_board_add);
							$echo_board_add = str_replace("[showing_num]", $reply_num, $echo_board_add);
							$echo_board_add = str_replace("[showing_body]", $cuerpo2, $echo_board_add);
							$echo_board_add = str_replace("[showing_button_quote]", $button_thread_quote, $echo_board_add);
							$echo_board_add = str_replace("[showing_button_ban]", $button_post_ban, $echo_board_add);
							$echo_board_add = str_replace("[showing_button_delete]", $button_post_delete, $echo_board_add);
							$echo_board .= $echo_board_add;
						}
						$num += 1;
						$reply_count += 1; #Aumentamos el contador de replies mostrados a +1.
						
					} #Se cierra el while de respuesta normal
					
					if ($reply_count <= $num_replies_base0 AND $thread == "") { #Si el numero de replies mostrados es igual al limite, mostramos el aviso de replies omitted.
							$usuario_consulta3 = mysql_query("SELECT nombre FROM posts WHERE foto <> '0' AND board = '".$board_letter."' AND reply='".$post_id."'") or die(mysql_error()."SELECT nombre FROM posts WHERE foto <> '0' AND board = '".$board_letter."' AND reply='".$post_id."'");
							$reply_with_images_count = mysql_num_rows($usuario_consulta3);
							mysql_free_result($usuario_consulta3);
							$show_replies_omitted = str_replace("Y", $reply_with_images_count - $images_count, $posts_omitted);
							$show_replies_omitted = str_replace("X", $num_replies_base1 - $reply_count, $show_replies_omitted);
							$echo_board_add = str_replace("[showing_num]", $registro_num, $match_replies_omitted);
							$echo_board_add = str_replace("[showing_replies_omitted]", $show_replies_omitted, $echo_board_add);
							$echo_board .= $echo_board_add;
						} # Fin de parte de replies normales
				mysql_free_result($usuario_consulta2);
			} #Fin de condicion de "si hay replies....."
			if ($thread == "") {
			$echo_board .= $match_end_thread_false;
			} else {
			$echo_board .= $match_end_thread_true;
			}
		} #Fin de condicion de que el numero de replies mostrados en la pagina no supere el limite
		$images_count = 0;
		$reply_count = 0;
	} #Aqu se cierra el "while" del hilo
} else {
	$echo_board .= $no_posts; #Si bueno...esto no suele pasar, pero por si acaso...se muestra si no hay posts.
}
mysql_free_result($usuario_consulta);
?>
